import { BackendOutputEntry, BackendOutputStorageStrategy } from '@aws-amplify/plugin-types';
import { Stack } from 'aws-cdk-lib';
/**
 * Implementation of BackendOutputStorageStrategy that stores config data in stack metadata and outputs
 */
export declare class StackMetadataBackendOutputStorageStrategy implements BackendOutputStorageStrategy<BackendOutputEntry> {
    private readonly stack;
    /**
     * Initialize the instance with a stack.
     *
     * If the stack is an AmplifyStack, set a parameter in SSM so the stack can be identified later by the project environment
     */
    constructor(stack: Stack);
    /**
     * Store construct output as stack output and add pending metadata to the metadata object.
     *
     * Metadata is not written to the stack until flush() is called
     */
    addBackendOutputEntry: (keyName: string, backendOutputEntry: BackendOutputEntry) => void;
}
//# sourceMappingURL=stack_metadata_output_storage_strategy.d.ts.map