# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

# [3.5.0-gen2-release.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.4.0...@aws-amplify/graphql-transformer-interfaces@3.5.0-gen2-release.0) (2024-03-27)

### Features

- add secrets manager as credential store for sql lambda ([#2289](https://github.com/aws-amplify/amplify-category-api/issues/2289)) ([affdb98](https://github.com/aws-amplify/amplify-category-api/commit/affdb988b499591c3a96608f772b637ddd8c3a0c))
- generic iam authorization ([#2385](https://github.com/aws-amplify/amplify-category-api/issues/2385)) ([550ee80](https://github.com/aws-amplify/amplify-category-api/commit/550ee803275817d25447ff1400d55eb1ad4cd0c2))

# [3.4.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.3.3...@aws-amplify/graphql-transformer-interfaces@3.4.0) (2024-02-28)

### Features

- add implicit fields to filter input ([#2236](https://github.com/aws-amplify/amplify-category-api/issues/2236)) ([f7ec601](https://github.com/aws-amplify/amplify-category-api/commit/f7ec6014d4eecfede186129a6ea19041780bafb3))

## [3.3.3](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.3.2...@aws-amplify/graphql-transformer-interfaces@3.3.3) (2023-12-18)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [3.3.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.3.1...@aws-amplify/graphql-transformer-interfaces@3.3.2) (2023-12-06)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [3.3.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.3.0...@aws-amplify/graphql-transformer-interfaces@3.3.1) (2023-11-22)

### Bug Fixes

- Allow custom SQL statements without model declarations ([#2087](https://github.com/aws-amplify/amplify-category-api/issues/2087)) ([ea5b26c](https://github.com/aws-amplify/amplify-category-api/commit/ea5b26cd554f5c74b6431cbad6ccf60ab556478f))

# [3.3.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.2.2...@aws-amplify/graphql-transformer-interfaces@3.3.0) (2023-11-15)

### Features

- add managed table support in API construct ([#2024](https://github.com/aws-amplify/amplify-category-api/issues/2024)) ([96a0d94](https://github.com/aws-amplify/amplify-category-api/commit/96a0d94fa872a5329da120f53be139833449b815)), closes [#1849](https://github.com/aws-amplify/amplify-category-api/issues/1849) [#1903](https://github.com/aws-amplify/amplify-category-api/issues/1903) [#1940](https://github.com/aws-amplify/amplify-category-api/issues/1940) [#1971](https://github.com/aws-amplify/amplify-category-api/issues/1971) [#1973](https://github.com/aws-amplify/amplify-category-api/issues/1973)
- add postgres engine and update types as needed ([#1979](https://github.com/aws-amplify/amplify-category-api/issues/1979)) ([5257d53](https://github.com/aws-amplify/amplify-category-api/commit/5257d53f1d4d02be71b34ddf6757f22dd5d74aff))
- Add SQL database support to AmplifyGraphqlApi construct ([#1986](https://github.com/aws-amplify/amplify-category-api/issues/1986)) ([2ff63a5](https://github.com/aws-amplify/amplify-category-api/commit/2ff63a540387d96cf10d8ae1975858a76d9ba045)), closes [#1917](https://github.com/aws-amplify/amplify-category-api/issues/1917) [#1983](https://github.com/aws-amplify/amplify-category-api/issues/1983)
- **api:** add vpc endpoints for ssm ([5a4ffc4](https://github.com/aws-amplify/amplify-category-api/commit/5a4ffc4c1889536c8e1fdd1f31fe28ca4326100f))
- **api:** custom queries support using sql directive ([5214037](https://github.com/aws-amplify/amplify-category-api/commit/52140374ca974956c5d5eac09fec91a51cfc9027))
- sql lambda provisioned concurrency ([#2055](https://github.com/aws-amplify/amplify-category-api/issues/2055)) ([d8c5bf0](https://github.com/aws-amplify/amplify-category-api/commit/d8c5bf0b7df3cdd1ad499380d24fe49a61acbc7e))
- transformer behavior of replacing table upon gsi updates ([#2067](https://github.com/aws-amplify/amplify-category-api/issues/2067)) ([c4b7530](https://github.com/aws-amplify/amplify-category-api/commit/c4b7530e0880b34d411fc2732fa199e4a28bcea1))

## [3.2.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.2.1...@aws-amplify/graphql-transformer-interfaces@3.2.2) (2023-11-02)

### Bug Fixes

- pass in and use correct lambda arn for lambdaauthorizers ([#2007](https://github.com/aws-amplify/amplify-category-api/issues/2007)) ([4114411](https://github.com/aws-amplify/amplify-category-api/commit/4114411ba6d086d46ac0e9967139cb287e3fc22b))

## [3.2.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.2.0...@aws-amplify/graphql-transformer-interfaces@3.2.1) (2023-10-05)

### Bug Fixes

- iam auth values can be passed as cdk tokens ([#1919](https://github.com/aws-amplify/amplify-category-api/issues/1919)) ([9297fa5](https://github.com/aws-amplify/amplify-category-api/commit/9297fa5cda87697645ad0c78b84c3004b32ac319))

# [3.2.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.1.2...@aws-amplify/graphql-transformer-interfaces@3.2.0) (2023-09-20)

### Features

- disable amplify cfn outputs for cdk apps ([0c72d18](https://github.com/aws-amplify/amplify-category-api/commit/0c72d1822f8e5ccb3e04a0a49049a459b5fb49e6))

## [3.1.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.1.1...@aws-amplify/graphql-transformer-interfaces@3.1.2) (2023-08-30)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [3.1.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@3.1.0...@aws-amplify/graphql-transformer-interfaces@3.1.1) (2023-08-28)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [3.1.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.3.0...@aws-amplify/graphql-transformer-interfaces@3.1.0) (2023-08-09)

### Features

- bump major version of transformer packages ([2458c84](https://github.com/aws-amplify/amplify-category-api/commit/2458c8426da5772aa669d37e11f99ee9c6c5ac2e))

# [2.3.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.5...@aws-amplify/graphql-transformer-interfaces@2.3.0) (2023-07-21)

### Features

- **graphql:** pull rds latest layer ([8325ef5](https://github.com/aws-amplify/amplify-category-api/commit/8325ef559b4bd5d86e9502bb1dc2cff833e7db0c))
- **graphql:** vpc support for sql lambda ([9cc4407](https://github.com/aws-amplify/amplify-category-api/commit/9cc4407bdc4799fe548919808961911a3d5995c7))

## [2.2.5](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.4...@aws-amplify/graphql-transformer-interfaces@2.2.5) (2023-07-17)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [2.2.4](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.3...@aws-amplify/graphql-transformer-interfaces@2.2.4) (2023-07-07)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [2.2.3](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.2...@aws-amplify/graphql-transformer-interfaces@2.2.3) (2023-06-29)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [2.2.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.1...@aws-amplify/graphql-transformer-interfaces@2.2.2) (2023-06-20)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [2.2.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.2.0...@aws-amplify/graphql-transformer-interfaces@2.2.1) (2023-06-05)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.2.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.1...@aws-amplify/graphql-transformer-interfaces@2.2.0) (2023-05-17)

### Bug Fixes

- remove DB info from schema global input ([d28a5cf](https://github.com/aws-amplify/amplify-category-api/commit/d28a5cfde7dbba31fe5540ef724b564c9c2eeef5))

### Features

- **graphql:** read datasource type from schema file ([d7f50e5](https://github.com/aws-amplify/amplify-category-api/commit/d7f50e5ca026a3bbf378437cf6a165cc5b438bb5))

## [2.1.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0...@aws-amplify/graphql-transformer-interfaces@2.1.1) (2023-03-15)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.4...@aws-amplify/graphql-transformer-interfaces@2.1.0) (2023-03-01)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.6](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.4...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.6) (2023-02-21)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.5](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.4...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.5) (2023-02-15)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.4](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.12...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.4) (2023-02-03)

### Bug Fixes

- lock CDK v2 version ([#923](https://github.com/aws-amplify/amplify-category-api/issues/923)) ([2afe40c](https://github.com/aws-amplify/amplify-category-api/commit/2afe40cf13e7d1ee7db37988b9b3297768c7bd0a))

### Features

- migrate index and model transformers to CDK v2 ([#860](https://github.com/aws-amplify/amplify-category-api/issues/860)) ([886ab6c](https://github.com/aws-amplify/amplify-category-api/commit/886ab6c1eb699f9a09f273c76b3c419c73004f9b))

# [2.1.0-beta.3](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.0...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.3) (2022-12-27)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.0...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.2) (2022-12-12)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.0...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.1) (2022-11-30)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-beta.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-cdkv2.2...@aws-amplify/graphql-transformer-interfaces@2.1.0-beta.0) (2022-11-18)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [2.1.0-cdkv2.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.9...@aws-amplify/graphql-transformer-interfaces@2.1.0-cdkv2.2) (2022-11-15)

### Bug Fixes

- lock CDK v2 version ([#923](https://github.com/aws-amplify/amplify-category-api/issues/923)) ([2afe40c](https://github.com/aws-amplify/amplify-category-api/commit/2afe40cf13e7d1ee7db37988b9b3297768c7bd0a))

### Features

- migrate index and model transformers to CDK v2 ([#860](https://github.com/aws-amplify/amplify-category-api/issues/860)) ([886ab6c](https://github.com/aws-amplify/amplify-category-api/commit/886ab6c1eb699f9a09f273c76b3c419c73004f9b))

# [2.1.0-cdkv2.1](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@2.1.0-cdkv2.0...@aws-amplify/graphql-transformer-interfaces@2.1.0-cdkv2.1) (2022-10-24)

### Bug Fixes

- lock CDK v2 version ([#923](https://github.com/aws-amplify/amplify-category-api/issues/923)) ([2afe40c](https://github.com/aws-amplify/amplify-category-api/commit/2afe40cf13e7d1ee7db37988b9b3297768c7bd0a))

# [2.1.0-cdkv2.0](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.7...@aws-amplify/graphql-transformer-interfaces@2.1.0-cdkv2.0) (2022-10-24)

### Features

- migrate index and model transformers to CDK v2 ([#860](https://github.com/aws-amplify/amplify-category-api/issues/860)) ([886ab6c](https://github.com/aws-amplify/amplify-category-api/commit/886ab6c1eb699f9a09f273c76b3c419c73004f9b))

## [1.14.12](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.11...@aws-amplify/graphql-transformer-interfaces@1.14.12) (2023-01-26)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.11](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.10...@aws-amplify/graphql-transformer-interfaces@1.14.11) (2023-01-12)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.10](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.9...@aws-amplify/graphql-transformer-interfaces@1.14.10) (2023-01-12)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.9](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.8...@aws-amplify/graphql-transformer-interfaces@1.14.9) (2022-11-08)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.8](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.7...@aws-amplify/graphql-transformer-interfaces@1.14.8) (2022-10-24)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.7](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.6...@aws-amplify/graphql-transformer-interfaces@1.14.7) (2022-08-16)

### Bug Fixes

- set cfn values correctly when applying lambda-based conflict resolution ([4542759](https://github.com/aws-amplify/amplify-category-api/commit/45427596bbcfcb83bda18a037b0b540bff812b25))

## [1.14.6](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.4...@aws-amplify/graphql-transformer-interfaces@1.14.6) (2022-07-20)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.5](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.4...@aws-amplify/graphql-transformer-interfaces@1.14.5) (2022-07-14)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.4](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.3...@aws-amplify/graphql-transformer-interfaces@1.14.4) (2022-06-13)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.3](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.0...@aws-amplify/graphql-transformer-interfaces@1.14.3) (2022-06-07)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.2](https://github.com/aws-amplify/amplify-category-api/compare/@aws-amplify/graphql-transformer-interfaces@1.14.0...@aws-amplify/graphql-transformer-interfaces@1.14.2) (2022-05-31)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.14.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.14.0...@aws-amplify/graphql-transformer-interfaces@1.14.1) (2022-05-02)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [1.14.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.13.1...@aws-amplify/graphql-transformer-interfaces@1.14.0) (2022-04-29)

### Features

- dedup appsync functions ([#10289](https://github.com/aws-amplify/amplify-cli/issues/10289)) ([1a5607c](https://github.com/aws-amplify/amplify-cli/commit/1a5607c3e40d3a8144fc5f66a1632d90f061ed99))

## [1.13.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.13.0...@aws-amplify/graphql-transformer-interfaces@1.13.1) (2022-04-18)

### Bug Fixes

- **graphql-model-transformer:** fix create mutation when index field is null ([#10073](https://github.com/aws-amplify/amplify-cli/issues/10073)) ([1e9d140](https://github.com/aws-amplify/amplify-cli/commit/1e9d140a529e5a2474968feb26b53ac7c9bb5750))

# [1.13.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.12.6...@aws-amplify/graphql-transformer-interfaces@1.13.0) (2022-01-31)

### Features

- `[@maps](https://github.com/maps)To` directive to enable renaming models while retaining data ([#9340](https://github.com/aws-amplify/amplify-cli/issues/9340)) ([aedf45d](https://github.com/aws-amplify/amplify-cli/commit/aedf45d9237812d71bb8b56164efe0222ad3d534))

## [1.12.6](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.12.5...@aws-amplify/graphql-transformer-interfaces@1.12.6) (2022-01-13)

### Bug Fixes

- clean up missing and unused GraphQL v2 dependencies ([#9486](https://github.com/aws-amplify/amplify-cli/issues/9486)) ([a6ca44e](https://github.com/aws-amplify/amplify-cli/commit/a6ca44e6ea0ec0a70b648e399fc3e849ccc2a7c9))

## [1.12.5](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.12.3...@aws-amplify/graphql-transformer-interfaces@1.12.5) (2022-01-10)

## 7.6.7 (2022-01-10)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.12.3](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.12.2...@aws-amplify/graphql-transformer-interfaces@1.12.3) (2021-11-21)

### Bug Fixes

- group response and request resolvers by slot ([#8980](https://github.com/aws-amplify/amplify-cli/issues/8980)) ([74cbcc3](https://github.com/aws-amplify/amplify-cli/commit/74cbcc3799201eea4b68c26f4e44ad6bee6704ad))

## [1.12.2](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.12.1...@aws-amplify/graphql-transformer-interfaces@1.12.2) (2021-11-17)

### Bug Fixes

- append apiKey if global auth is enabled and its not default auth ([#8843](https://github.com/aws-amplify/amplify-cli/issues/8843)) ([3aadcde](https://github.com/aws-amplify/amplify-cli/commit/3aadcde2225f0ede5c5d94c2a4cd9d1afece5288))
- passing ddb params from root to nested model stacks ([#8766](https://github.com/aws-amplify/amplify-cli/issues/8766)) ([7124cc0](https://github.com/aws-amplify/amplify-cli/commit/7124cc0c8df9fa3261b51141184c0c635bdff738))

## [1.12.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.10.1...@aws-amplify/graphql-transformer-interfaces@1.12.1) (2021-11-15)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.10.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.10.0...@aws-amplify/graphql-transformer-interfaces@1.10.1) (2021-11-11)

### Bug Fixes

- **graphql-model-transformer:** override resource logical id to fix v1 to v2 transformer migration ([#8597](https://github.com/aws-amplify/amplify-cli/issues/8597)) ([e3a2afb](https://github.com/aws-amplify/amplify-cli/commit/e3a2afbbed6e97f143fc7c83064e2193f4c91bdd))
- move [@model](https://github.com/model) params to root stack and fix ds logical id ([#8736](https://github.com/aws-amplify/amplify-cli/issues/8736)) ([df4408c](https://github.com/aws-amplify/amplify-cli/commit/df4408c4080949ddd638778df9ae20e763dd5824))

# [1.10.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.9.1...@aws-amplify/graphql-transformer-interfaces@1.10.0) (2021-10-10)

### Features

- **graphql-model-transformer:** index/primarykey datastore selective sync capability ([#8240](https://github.com/aws-amplify/amplify-cli/issues/8240)) ([e108783](https://github.com/aws-amplify/amplify-cli/commit/e10878370a4785a412b561002d78b5cec9859346))

## [1.9.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.9.0...@aws-amplify/graphql-transformer-interfaces@1.9.1) (2021-09-27)

### Bug Fixes

- **graphql-model-transformer:** [@model](https://github.com/model) conflict resolution ([#8035](https://github.com/aws-amplify/amplify-cli/issues/8035)) ([f3bdc4a](https://github.com/aws-amplify/amplify-cli/commit/f3bdc4ac1fcf596f634d9d2e968785e76f7b138c))
- **graphql-model-transformer:** iam role name does not exceed 64 characters ([#8244](https://github.com/aws-amplify/amplify-cli/issues/8244)) ([812a671](https://github.com/aws-amplify/amplify-cli/commit/812a67163d6dd33160bf7ace9afd538c83a7af1a))

# [1.9.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.8.2...@aws-amplify/graphql-transformer-interfaces@1.9.0) (2021-09-02)

### Features

- add new relational modeling directives ([#7997](https://github.com/aws-amplify/amplify-cli/issues/7997)) ([e9cdb7a](https://github.com/aws-amplify/amplify-cli/commit/e9cdb7a1a45b8f16546952a469ab2d45f82e855c))

## [1.8.2](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.8.1...@aws-amplify/graphql-transformer-interfaces@1.8.2) (2021-08-24)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

## [1.8.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.8.0...@aws-amplify/graphql-transformer-interfaces@1.8.1) (2021-08-06)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [1.8.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.7.0...@aws-amplify/graphql-transformer-interfaces@1.8.0) (2021-07-30)

### Features

- capability injection for the vNext GraphQL Transformer ([#7735](https://github.com/aws-amplify/amplify-cli/issues/7735)) ([f3eae13](https://github.com/aws-amplify/amplify-cli/commit/f3eae13ab2848df398e26429abf985b756abcff2))

# [1.7.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.6.1...@aws-amplify/graphql-transformer-interfaces@1.7.0) (2021-07-12)

### Features

- port [@predictions](https://github.com/predictions) to GraphQL Transformer v2 ([#7387](https://github.com/aws-amplify/amplify-cli/issues/7387)) ([3f2e647](https://github.com/aws-amplify/amplify-cli/commit/3f2e647b9dfe14aa5919b46f53342937dd0c7fa9))

## [1.6.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.6.0...@aws-amplify/graphql-transformer-interfaces@1.6.1) (2021-06-24)

### Bug Fixes

- correct 'tranformer' typo ([#7408](https://github.com/aws-amplify/amplify-cli/issues/7408)) ([9420f1b](https://github.com/aws-amplify/amplify-cli/commit/9420f1b29137fd7621d7d902a147e596776357df))

# [1.6.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.5.0...@aws-amplify/graphql-transformer-interfaces@1.6.0) (2021-05-18)

### Features

- port [@searchable](https://github.com/searchable) to GraphQL Transformer v2 ([#7291](https://github.com/aws-amplify/amplify-cli/issues/7291)) ([37a2df2](https://github.com/aws-amplify/amplify-cli/commit/37a2df2365fe4bf0eddf285a159221e34f695fe2))

# [1.5.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.3.1...@aws-amplify/graphql-transformer-interfaces@1.5.0) (2021-05-03)

## 4.50.1 (2021-05-03)

### Features

- **graphql-function-transformer:** port [@function](https://github.com/function) to v2 ([#7055](https://github.com/aws-amplify/amplify-cli/issues/7055)) ([463e975](https://github.com/aws-amplify/amplify-cli/commit/463e97593d5486d1f9d10bcabde26d3e36dee7f2))

# [1.4.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.3.1...@aws-amplify/graphql-transformer-interfaces@1.4.0) (2021-05-03)

### Features

- **graphql-function-transformer:** port [@function](https://github.com/function) to v2 ([#7055](https://github.com/aws-amplify/amplify-cli/issues/7055)) ([463e975](https://github.com/aws-amplify/amplify-cli/commit/463e97593d5486d1f9d10bcabde26d3e36dee7f2))

## [1.3.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.3.0...@aws-amplify/graphql-transformer-interfaces@1.3.1) (2021-02-11)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# [1.3.0](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.2.1...@aws-amplify/graphql-transformer-interfaces@1.3.0) (2020-12-11)

### Features

- container-based deployments([#5727](https://github.com/aws-amplify/amplify-cli/issues/5727)) ([fad6377](https://github.com/aws-amplify/amplify-cli/commit/fad6377bd384862ca4429cb1a83eee90efd62b58))

## [1.2.1](https://github.com/aws-amplify/amplify-cli/compare/@aws-amplify/graphql-transformer-interfaces@1.1.0...@aws-amplify/graphql-transformer-interfaces@1.2.1) (2020-11-22)

**Note:** Version bump only for package @aws-amplify/graphql-transformer-interfaces

# 1.2.0 (2020-11-22)

### Features

- transformer redesign ([#5534](https://github.com/aws-amplify/amplify-cli/issues/5534)) ([a93c685](https://github.com/aws-amplify/amplify-cli/commit/a93c6852f6588898ebc52b0574f4fcc3d2e87948))

# 1.1.0 (2020-11-08)

### Features

- transformer redesign ([#5534](https://github.com/aws-amplify/amplify-cli/issues/5534)) ([a93c685](https://github.com/aws-amplify/amplify-cli/commit/a93c6852f6588898ebc52b0574f4fcc3d2e87948))
